/*
	Raw Socker Constructor
libsock sample program
REQUIRED: libsock
	http://www.mojodo.it/coded/libsock.tar.gz
*/


#include <stdio.h>
#include <stdlib.h>
#include <libsock.h>
#include <getopt.h>

#define VERSION "2.1a"

const        char    _info[]="Mojodo Project Code ,no (c) 2002";
const        char    __info[]="Avatar Corp. ,no (c) 2002";
const        char    ___info[]="GNU/GPL";

struct packethdr{
	char *prot;
	char *saddr;
	char *daddr;
	unsigned char *data;
	int  dport;
	int  sport;
	int  type;
	int  code;
};

int getopt_long_only(int argc, char * const argv[],const char *optstring,const struct option *longopts, int *longindex);
int main(int argc, char **argv);
void usage(char *bin);

int main(int argc, char **argv){
	int opt_index,v6=0;
	char c, *pktdata;
	struct packethdr packet;
	struct ls_tcpflags flags;
	struct ls_settings settings;
	struct ls_v6opt options;
	struct ls_icmp6 icmpinfo;
struct ls_v6opt {
	int flow_label,
	    hop_limit;
	char device[10];
	};

	struct option opzioni[]={
                   {"flow", 1, 0, 0},
                   {"hopl", 1, 0, 0},
                   {"dev", 1, 0, 0},
		   {"saddr", 1, 0, 0},
                   {"daddr", 1, 0, 0},
                   {"data",  1, 0, 0},
                   {"sport", 1, 0, 0},
                   {"dport", 1, 0, 0},
		   {"type",  1, 0, 0},
	           {"code",  1, 0, 0},
		   {"ack_seq",1,0, 0},
		   {"window",1, 0, 0},
		   {"urg_ptr",1,0, 0},
		   {"seq",   1, 0, 0},
		   {"doff",  1, 0, 0},
		   {"res1",  1, 0, 0},
		   {"res2",  1, 0, 0},
		   {"urg",   0, 0, 0},
		   {"ack",   0, 0, 0},
		   {"psh",   0, 0, 0},
		   {"rst",   0, 0, 0},
		   {"syn",   0, 0, 0},
		   {"fin",   0, 0, 0},
		   {"help",   0, 0, 0},
		   {0, 0, 0, 0}
               };
	if (argc < 4)
		{
		usage(argv[0]);
		exit(-1);
		}
	memset(&packet,0, sizeof(struct packethdr));
	memset(&flags,0, sizeof(struct ls_tcpflags));
	memset(&settings,0, sizeof(struct ls_settings));
	memset(&options,0,sizeof(struct ls_v6opt));
	while ((c=getopt_long(argc,argv,"6h:p:dev:help:saddr:daddr:data:sport:dport:ack_seq:window:urg_ptr:seq:doff:res2:res1:urg:ack:psh:rst:fin:syn:",opzioni,&opt_index))!=-1){
	       switch (c) {
               case 0:
                   if (strstr(opzioni[opt_index].name,"help")){
			usage(argv[0]);
			exit(0);
		   }
		   else if (strstr(opzioni[opt_index].name,"flow")){
		   	options.flow_label=atoi(optarg);
		   }
		   else if (strstr(opzioni[opt_index].name,"hopl")){
		   	options.hop_limit=atoi(optarg);
		   }
		   else if (strstr(opzioni[opt_index].name,"dev")){
			memcpy(options.device,optarg,strlen(optarg));
		   }
		   else if (strstr(opzioni[opt_index].name,"saddr")){
			packet.saddr=malloc(strlen(optarg));
			memcpy(packet.saddr,optarg,strlen(optarg));
		   }
                   else if (strstr(opzioni[opt_index].name,"daddr")){
			packet.daddr=malloc(strlen(optarg));
			memcpy(packet.daddr,optarg,strlen(optarg));
		   }
                   else if (strstr(opzioni[opt_index].name,"data")){
			packet.data=malloc(strlen(optarg));
			memcpy(packet.data,optarg,strlen(optarg));
		   }
                   else if (strstr(opzioni[opt_index].name,"sport"))
			packet.sport=atoi(optarg);
                   else if (strstr(opzioni[opt_index].name,"dport"))
			packet.dport=atoi(optarg);
                   else if (strstr(opzioni[opt_index].name,"ack_seq"))
			settings.ack_seq=atoi(optarg);
                   else if (strstr(opzioni[opt_index].name,"window"))
			settings.window=atoi(optarg);
                   else if (strstr(opzioni[opt_index].name,"urg_prt"))
			settings.urg_ptr=atoi(optarg);
                   else if (strstr(opzioni[opt_index].name,"seq"))
			settings.seq=atoi(optarg);
		   else if (strstr(opzioni[opt_index].name,"doff"))
			flags.doff=atoi(optarg);
		   else if (strstr(opzioni[opt_index].name,"res1"))
			flags.res1=atoi(optarg);
		   else if (strstr(opzioni[opt_index].name,"res2"))
			flags.res2=atoi(optarg);
		   else if (strstr(opzioni[opt_index].name,"urg"))
			flags.urg=1;
		   else if (strstr(opzioni[opt_index].name,"psh"))
			flags.psh=1;
		   else if (strstr(opzioni[opt_index].name,"ack"))
			flags.ack=1;
   		   else if (strstr(opzioni[opt_index].name,"rst"))
			flags.rst=1;
   		   else if (strstr(opzioni[opt_index].name,"syn"))
			flags.syn=1;
   		   else if (strstr(opzioni[opt_index].name,"fin"))
			flags.fin=1;
		   else if (strstr(opzioni[opt_index].name,"type"))
			packet.type=atoi(optarg);
                   else if (strstr(opzioni[opt_index].name,"code"))
			packet.code=atoi(optarg);
		   break;
		case 'p':
		   packet.prot=malloc(strlen(optarg));
		   memcpy(packet.prot,optarg,strlen(optarg));
		   break;
		case 'h':
		   usage(argv[0]);
		   exit(0);
		   break;
		case '6':
		   v6++;
		}
	}
	fprintf(stdout,"Raw Socket Constructor :\n");
	if(!packet.prot){
		fprintf(stdout,"\terror: -p required {tcp,udp,icmp}\n");
		exit(-1);
		}
	else if(!packet.saddr){
		fprintf(stdout,"\terror: -saddr required source address\n");
		exit(-1);
		}
	else if(!packet.daddr){
		fprintf(stdout,"\terror: -daddr required destination address\n");
		exit(-1);
		}
	else if((!packet.sport) && ((strstr(packet.prot,"tcp")) || (strstr(packet.prot,"udp")))) {
		fprintf(stdout,"\terror: -sport required source port with tcp and udp protocol\n");
		exit(-1);
		}
	else if((!packet.dport) && ((strstr(packet.prot,"tcp")) || (strstr(packet.prot,"udp")))) {
		fprintf(stdout,"\terror: -dport required destination port with tcp and udp protocol\n");
		exit(-1);
		}
	if((!options.device) && (v6==1) ) {
		fprintf(stdout,"\terror: -dev required device for ipv6 protocl\n");
		exit(-1);
		}

	if(!packet.data){
		pktdata=NODATA;
		}
	else{
		pktdata=malloc(strlen(packet.data));
		memcpy(pktdata,packet.data,strlen(packet.data));
		}
	fprintf(stdout,"  src  ip : %s\n",packet.saddr);
	fprintf(stdout,"  dest ip : %s\n",packet.daddr);
	fprintf(stdout,"  src  port : %d\n",packet.sport);
	fprintf(stdout,"  dest port : %d\n",packet.dport);
	fprintf(stdout,"  protocol : %s",packet.prot);

	if (!v6){
		struct ls_ip ip4;
		memset(&ip4,0, sizeof(struct ls_ip));
		ip4.tos=0;
		ip4.frag_off=0x00;
		ip4.ttl=1;
		ip4.id=rand();
		fprintf(stdout,"\n");
		if (strstr(packet.prot,"tcp")){
			ls_sendtcp(&ip4,packet.saddr,packet.daddr,packet.sport,packet.dport,pktdata,0,flags,settings);
			}
		else if (strstr(packet.prot,"udp")){
			ls_sendudp(&ip4,packet.saddr,packet.daddr,packet.sport,packet.dport,pktdata,0);
			}
		else if (strstr(packet.prot,"icmp")){
			ls_sendicmp(&ip4,packet.saddr,packet.daddr,packet.type,packet.code,pktdata,0);
			}
	}
	else {
		fprintf(stdout,"-ipv6\n");
		if (strstr(packet.prot,"tcp")){
			ls_sendtcp6(packet.saddr,packet.daddr,packet.sport,packet.dport,pktdata,0,flags,settings,options);
			}
		else if (strstr(packet.prot,"udp")){
			ls_sendudp6(packet.saddr,packet.daddr,packet.sport,packet.dport,pktdata,0,options);
			}
		else if (strstr(packet.prot,"icmp")){
			ls_sendicmp6(packet.saddr,packet.daddr,icmpinfo,NODATA,0,options);
			}

	}
	fprintf(stdout,"  packet sent.\n");
	exit(0);
}

void usage(char *bin){
	fprintf(stdout,"Raw Socket Constructor:\n");
	fprintf(stdout,"   Coder: ValK + Version %s\n" ,VERSION);
	fprintf(stdout,"   %s code\n   info:\n   %s\n   %s\n",___info,_info,__info);
	fprintf(stdout,"   usage: %s -6 {ipv6} -p {tcp,udp,icmp} --saddr --daddr --data \"here data if any\" [option if any]\n",bin);
	fprintf(stdout,"option:\n");
	fprintf(stdout,"\t* TCP:\n");
	fprintf(stdout,"\t\t[SETTINGS]\n");
	fprintf(stdout,"\t\t--sport value\n\t\t--dport value\n\t\t--seq value\n\t\t--ack_seq value\n\t\t--window value\n\t\t--urg_ptr value\n");
	fprintf(stdout,"\t\t[FLAGS]\n");
	fprintf(stdout,"\t\t--doff value\n\t\t--res1 value\n\t\t--res2 value\n\t\t--urg\n\t\t--ack\n\t\t--psh\n\t\t--rst\n\t\t--syn\n\t\t--fin\n");
	fprintf(stdout,"\t* UDP:\n");
	fprintf(stdout,"\t\t[SETTINGS]\n");
	fprintf(stdout,"\t\t--sport value\n\t\t--dport value\n");
	fprintf(stdout,"\t* ICMP:\n");
	fprintf(stdout,"\t\t[SETTINGS]\n");
	fprintf(stdout,"\t\t--type value\n\t\t--code value\n");
	fprintf(stdout,"\t* IPv6 Needed:\n");
	fprintf(stdout,"\t\t[SETTINGS]\n");
	fprintf(stdout,"\t\t--flow {flow label value}\n\t\t--hopl {hop limit value}\n\t\t--dev {ipv6 device, eth0,sit0, etc.}\n");

}
